(*
 *  beware ircd, Internet Relay Chat server, bcreationdate.dpr
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

program bcreationdate;

uses
  btime,
  pgtypes,
  sysutils;

function timestrcreation(i:integer):bytestring;
const
  weekday:array[0..6] of string[4]=('Thu','Fri','Sat','Sun','Mon','Tue','Wed');
  month:array[0..11] of string[4]=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
var
  y,m,d,h,min,sec,ms:word;
  t:tdatetime;
begin
  t := unixtoole(i);
  decodedate(t,y,m,d);
  decodetime(t,h,min,sec,ms);
  result := weekday[i div 86400 mod 7]+' '+month[m-1]+' '+inttostr(d)+' '+inttostr(y)+' at '+
  inttostr(h div 10)+inttostr(h mod 10)+':'+inttostr(min div 10)+inttostr(min mod 10)+':'+inttostr(sec div 10)+inttostr(sec mod 10);
end;

var
  t:textfile;
begin
  btime.init;
  assign(t,'bcreationdate.pas');
  rewrite(t);
  writeln(t,'unit bcreationdate;');
  writeln(t);
  writeln(t,'interface');
  writeln(t);
  writeln(t,'{Automatically generated by bcreationdate.dpr}');
  writeln(t);
  writeln(t,'const');
  writeln(t,'  creationdateint='+inttostr(irctime)+';');
  writeln(t,'  creationdatestr='''+timestrcreation(irctime)+' GMT'';');
  writeln(t);
  writeln(t,'implementation');
  writeln(t);
  writeln(t,'end.');
  closefile(t);
end.

